using ProtoBuf;
using System.Collections.Generic;

namespace Protocols
{

    /// <summary>
    /// 性别
    /// </summary>
    public enum ERoleSex
    {
        Other = 0,//未知
        Boy = 1, // 男
        Girl = 2, // 女 
    }

    /// <summary>
    /// 玩家状态
    /// </summary>
    public enum EPlayerState : uint
    {
        [EnumDescription("正常")] Play = 0,
        [EnumDescription("战斗")] Battle = 1,
    }

    ///// <summary>
    ///// 玩家数据
    ///// </summary>
    //[ProtoContract]
    //public class stPlayerData
    //{
    //    [ProtoMember(1)] public string Account = string.Empty;                  //账号
    //    [ProtoMember(2)] public string NickName = string.Empty;                 //角色昵称
    //    [ProtoMember(3)] public ERoleSex Sex = ERoleSex.Boy;                    //角色性别
    //    [ProtoMember(4)] public string SelfIp = string.Empty;                   //自己的外网IP
    //    [ProtoMember(5)] public ulong AccountId = 0;                            //账号ID
    //    [ProtoMember(6)] public string HeadUrl = string.Empty;                  //头像
    //    [ProtoMember(7)] public List<string> HeadUrls = new List<string>();     //全部头像
    //    [ProtoMember(8)] public ulong WorldId = 0;                              //世界ID         
    //}

    //[ProtoContract]
    //public class stSimpleUser
    //{
    //    [ProtoMember(1)] public ulong userId = 0;                   //用户ID
    //    [ProtoMember(2)] public string nickName = string.Empty;     //用户昵称
    //    [ProtoMember(3)] public string headUrl = string.Empty;      //用户头像
    //}

    #region 玩家货币

    /// <summary>
    /// 货币类型
    /// </summary>
    public enum EPurseType
    {
        None,
        COIN = 1,//金币
        MAKE = 2,//MAKE币
        USDT = 3,//USDT币
    }

    ///// <summary>
    ///// 玩家货币修改通知
    ///// </summary>
    //[ProtoContract]
    //public class PlayerPurseChangeNtf : ProtoBody
    //{
    //    //货币类型
    //    [ProtoMember(1)] public EPurseType Type = EPurseType.None;
    //    //当前数量
    //    [ProtoMember(2)] public float CurNum = 0;
    //    //变化数量
    //    [ProtoMember(3)] public float ChangNum = 0;
    //}

    ///// <summary>
    ///// 玩家修改名字请求
    ///// </summary>
    //public class PlayerChangeNameReq : ProtoBody
    //{
    //    //名字
    //    [ProtoMember(1)] public string name = string.Empty;
    //}

    /// <summary>
    /// 玩家修改名字返回
    /// </summary>
    public class PlayerChangeNameRsp : ProtoBody
    {
        public enum ErrorID
        {
            //成功
            Success = 0,
            //失败
            Failed = 1,
        }

        //[ProtoMember(1)] public ErrorID errorID;

        ////新名字
        //[ProtoMember(2)] public string newName = string.Empty;
    }

    ///// <summary>
    ///// 玩家下线请求
    ///// </summary>
    //public class PlayerOfflineReq : ProtoBody
    //{
    //}

    ///// <summary>
    ///// 玩家下线返回
    ///// </summary>
    public class PlayerOfflineRsp : ProtoBody
    {
        public enum ErrorID
        {
            //成功
            Success = 0,
            //失败
            Failed = 1,
        }

        //[ProtoMember(1)] public ErrorID errorID;
    }

    ///// <summary>
    ///// 玩家修改头像请求
    ///// </summary>
    //public class PlayerChangeHeadReq : ProtoBody
    //{
    //    //头像
    //    [ProtoMember(1)] public string headUrl = string.Empty;
    //}

    /// <summary>
    /// 玩家修改头像返回
    /// </summary>
    public class PlayerChangeHeadRsp : ProtoBody
    {
        public enum ErrorID
        {
            //成功
            Success = 0,
            //失败
            Failed = 1,
        }

        //[ProtoMember(1)] public ErrorID errorID;

        ////新头像
        //[ProtoMember(2)] public string headUrl = string.Empty;
    }

    ///// <summary>
    ///// 玩家获得头像通知
    ///// </summary>
    //public class PlayerGetHeadNtf : ProtoBody
    //{
    //    //头像
    //    [ProtoMember(1)] public string headUrl = string.Empty;
    //}
    #endregion

    #region 玩家道具

    ///// <summary>
    ///// 玩家道具修改通知
    ///// </summary>
    //[ProtoContract]
    //public class PlayerPropChangeNtf : ProtoBody
    //{
    //    /// <summary>
    //    /// 货币类型
    //    /// </summary>
    //    [ProtoMember(1)]
    //    public EPropType Type = EPropType.None;

    //    /// <summary>
    //    /// 当前数量
    //    /// </summary>
    //    [ProtoMember(2)]
    //    public float CurNum = 0;

    //    /// <summary>
    //    /// 变化数量
    //    /// </summary>
    //    [ProtoMember(3)]
    //    public float ChangNum = 0;
    //}

    /// <summary>
    /// 道具类型
    /// </summary>
    public enum EPropType
    {
        None,
        COIN = 1001,// 货币-金币
        MAKE = 1002,// 货币-MAKE币
        USDT = 1003,// 货币-USDT币
        DragonCaveKey = 2001,// 道具-龙窟钥匙
        DragonCaveToken = 2002,// 道具-龙窟令牌
        StarBreak = 2003,// 道具-星级突破
        SummonStoneC = 2004,// 道具-召唤宝石C
        SummonStoneB = 2005,// 道具-召唤宝石B
        SummonStoneA = 2006,// 道具-召唤宝石A
        SummonStoneS = 2007,// 道具-召唤宝石S
        SummonStoneSS = 2008,// 道具-召唤宝石SS
    }

    /// <summary>
    /// 道具品质
    /// </summary>
    public enum EPropQuality
    {
        LevelC,// 品质C
        LevelB,// 品质B
        LevelA,// 品质A
        LevelS,// 品质S
        LevelSS,// 品质SS
    }
    #endregion

    #region 玩家信息

    ///// <summary>
    ///// 玩家信息
    ///// </summary>
    //[ProtoContract]
    //public class stPlayerInfo
    //{
    //    //基本信息
    //    [ProtoMember(1)] public stSimpleUser SimpleUser = new stSimpleUser();
    //    //已创建天数
    //    [ProtoMember(2)] public int CreatedDay = 0;
    //    //发表动态数量
    //    [ProtoMember(3)] public int DynamicCount = 0;
    //    //标签Id列表
    //    [ProtoMember(4)] public List<uint> TagList = new List<uint>();
    //    //关注数量
    //    [ProtoMember(5)] public int FocusCount = 0;
    //    //粉丝数量
    //    [ProtoMember(6)] public int FinesCount = 0;
    //}

    ///// <summary>
    ///// 获取玩家标签列表请求
    ///// </summary>
    //[ProtoContract]
    //public class GetPlayerTagsReq : ProtoBody
    //{
    //    //用户ID
    //    [ProtoMember(1)] public ulong UserId = 0;
    //}

    /// <summary>
    /// 获取玩家标签列表返回
    /// </summary>
    [ProtoContract]
    public class GetPlayerTagsRsp : ProtoBody
    {
        public enum ErrorID
        {
            //成功
            Success = 0,
            //失败
            Failed = 1,
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////用户Id
        //[ProtoMember(2)] public ulong UserId = 0;
        ////标签列表-前端根据id读表显示
        //[ProtoMember(3)] public List<uint> TagList = new List<uint>();
    }

    ///// <summary>
    ///// 修改玩家标签请求
    ///// </summary>
    //[ProtoContract]
    //public class ChangePlayerTagReq : ProtoBody
    //{
    //    //标签Id列表
    //    [ProtoMember(1)] public List<uint> TagList = new List<uint>();
    //}

    /// <summary>
    /// 修改玩家标签返回
    /// </summary>
    [ProtoContract]
    public class ChangePlayerTagRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////修改后的标签列表-前端根据Id读表显示
        //[ProtoMember(2)] public List<uint> TagList = new List<uint>();
    }

    ///// <summary>
    ///// 获取玩家信息请求
    ///// </summary>
    //[ProtoContract]
    //public class GetPlayerInfoReq : ProtoBody
    //{
    //    //玩家Id
    //    [ProtoMember(1)] public ulong UserId = 0;
    //}

    /// <summary>
    /// 获取玩家信息返回
    /// </summary>
    [ProtoContract]
    public class GetPlayerInfoRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////玩家Id
        //[ProtoMember(2)] public stPlayerInfo PlayerInfo = new stPlayerInfo();
    }

    /// <summary>
    /// 匹配好友筛选
    /// </summary>
    public enum EMatchFriendFilter
    {
        None,   //不限
        Man,    //男
        Woman   //女
    }

    ///// <summary>
    ///// 好友条目
    ///// </summary>
    //[ProtoContract]
    //public class stFriendItem
    //{
    //    //简单信息
    //    [ProtoMember(1)] public stSimpleUser SimpleUser = new stSimpleUser();
    //    //已创建天数
    //    [ProtoMember(2)] public int CreatedDay = 0;
    //    //发表动态数量
    //    [ProtoMember(3)] public int DynamicCount = 0;
    //    //最新动态
    //    [ProtoMember(4)] public string NewDynamic = string.Empty;
    //}


    ///// <summary>
    ///// 获取关注列表请求
    ///// </summary>
    //[ProtoContract]
    //public class GetFocusListReq : ProtoBody
    //{
    //    //玩家Id
    //    [ProtoMember(1)] public ulong UserId = 0;
    //}

    /// <summary>
    /// 获取关注列表返回
    /// </summary>
    //[ProtoContract]
    public class GetFocusListRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////关注列表
        //[ProtoMember(2)] public List<stFriendItem> FocusList = new List<stFriendItem>();
    }

    ///// <summary>
    ///// 获取粉丝列表请求
    ///// </summary>
    //[ProtoContract]
    //public class GetFinesListReq : ProtoBody
    //{
    //    //玩家Id
    //    [ProtoMember(1)] public ulong UserId = 0;
    //}

    /// <summary>
    /// 获取粉丝列表返回
    /// </summary>
    [ProtoContract]
    public class GetFinesListRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////粉丝列表
        //[ProtoMember(2)] public List<stFriendItem> FinesList = new List<stFriendItem>();
    }

    ///// <summary>
    ///// 随机匹配好友请求
    ///// </summary>
    //[ProtoContract]
    //public class RandMatchFrindReq : ProtoBody
    //{
    //    //筛选条件
    //    [ProtoMember(1)] public EMatchFriendFilter MatchFilter = EMatchFriendFilter.None;
    //}

    /// <summary>
    /// 随机匹配好友返回
    /// </summary>
    //[ProtoContract]
    public class RandMatchFrindRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
            UnMatched = 2,//未匹配到
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////匹配好友信息
        ////[ProtoMember(2)] public stPlayerInfo FriendInfo = new stPlayerInfo();
        //[ProtoMember(2)] public List<stPlayerInfo> FriendList = new List<stPlayerInfo>();
    }

    ///// <summary>
    ///// 取消关注请求
    ///// </summary>
    //[ProtoContract]
    //public class CancelFocusReq : ProtoBody
    //{
    //    //好友ID
    //    [ProtoMember(1)] public ulong friendId = 0;
    //}

    /// <summary>
    /// 取消关注返回
    /// </summary>
    [ProtoContract]
    public class CancelFocusRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
            UnMatched = 2,//未匹配到
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////好友ID
        //[ProtoMember(2)] public ulong friendId = 0;
    }

    ///// <summary>
    ///// 关注玩家请求
    ///// </summary>
    //[ProtoContract]
    //public class FocusPlayerReq : ProtoBody
    //{
    //    /// <summary>
    //    /// 玩家ID
    //    /// </summary>
    //    [ProtoMember(1)]
    //    public ulong friendId = 0;
    //}

    /// <summary>
    /// 关注玩家返回
    /// </summary>
    [ProtoContract]
    public class FocusPlayerRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
        }
        //[ProtoMember(1)] public ErrorID errorID;
    }

    #endregion

    #region 装扮


    ///// <summary>
    ///// 获取玩家角色组件列表请求
    ///// </summary>
    //[ProtoContract]
    //public class GetPlayerPartsReq : ProtoBody
    //{

    //}

    /// <summary>
    /// 获取玩家角色组件列表返回
    /// </summary>
    [ProtoContract]
    public class GetPlayerPartsRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////角色组件列表
        //[ProtoMember(2)] public List<uint> parts = new List<uint>();
    }

    ///// <summary>
    ///// 玩家创建组件请求
    ///// </summary>
    //[ProtoContract]
    //public class PlayerCreateReq : ProtoBody
    //{
    //    //性别
    //    [ProtoMember(1)] public ERoleSex sex = ERoleSex.Boy;
    //    //昵称
    //    [ProtoMember(2)] public string nickname = "";
    //    //角色组件列表
    //    [ProtoMember(3)] public List<uint> parts = new List<uint>();
    //}

    /// <summary>
    /// 玩家创建组件返回
    /// </summary>
    [ProtoContract]
    public class PlayerCreateRsp : ProtoBody
    {
        public enum ErrorID
        {
            Success = 0,//成功
            Failed = 1,//失败
        }
        //[ProtoMember(1)] public ErrorID errorID;
        ////性别
        //[ProtoMember(2)] public ERoleSex sex = ERoleSex.Boy;
        ////昵称
        //[ProtoMember(3)] public string nickname = "";
        ////角色组件列表
        //[ProtoMember(4)] public List<uint> parts = new List<uint>();
    }


    #endregion


}
